/*
bldbt.c Version 0.2.0  Btree build test database
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* Usage: bldbt filename */

#include <bthash.h>

#define MAXLMT 999999

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage:   %s filename "
      "#records\n", pgm);
   fprintf(stderr,"Example: %s test.bt 100\n", pgm);
   fprintf(stderr,"#records is 1 - %d\n",
      MAXLMT);
   exit(1);
   } /* putstx */

int main(argc,argv)
int argc;
char **argv;
   {
   int opnerr;
   int i;
   int rslt;
   int lmt;
   btreefmt *bthdr;
   char *p,*q;
   unsigned char *rndSeed;
   unsigned char str[4096];
   unsigned char dbname[256];
   if (argc != 3) putstx(*argv);
   strcpy((char *) dbname,(char *) *(argv+1));
   lmt = (int) atoi(*(argv+2));
   if (lmt < 1 || lmt > MAXLMT) putstx(*argv);

   rndSeed = (unsigned char *) rndinit();
   if (rndSeed == NULL)
      {
      fprintf(stderr,"bldbt: rndinit error\n");
      exit(1);
      } /* rndinit err */

   bthdr = (btreefmt *) btopen((char *) dbname,UPDT,LOCK,&opnerr);
   if (bthdr == NULL)
      {
      fprintf(stderr,"bldbt: open "
	 "error %d\n", opnerr);
      free(rndSeed);
      return(0);
      } /* open error */
   /* process starts here */

   rslt = 0;
   i = lmt;
   while (!rslt && (i--))
      {
      p = (char *) str;
      q = (char *) p + bthdr->keyofst;
      while (p < q)
	 {
	 *p++ = rndnum(26,rndSeed) + 'a';
	 } /* for each char in pre-key */
      q = (char *) p + bthdr->keylen;
      while (p < q)
	 {
	 *p++ = rndnum(26,rndSeed) + 'A';
	 } /* for each char in key */
      q = (char *) str + bthdr->rcdlen;
      while (p < q)
	 {
	 *p++ = rndnum(26,rndSeed) + 'a';
	 } /* for each char in post-key */
      *p = '\0';
      rslt = btisrt(bthdr,ROOT,str);
      if (rslt)
	 {
	 fprintf(stderr,"bldbt: btisrt rslt %d\n",
	    rslt);
	 exit(1);
	 } /* btisrt err */
      } /* insert loop */

   /**********************************************************/
   btclose(bthdr);
   return(0);
   } /* main */
